// StatusMonitorDlg.cpp : Implementation
//
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

#include "stdafx.h"
#include "StatusMonitor.h"
#include "StatusMonitorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog for version information

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// dialog data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // support DDX/DDV
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStatusMonitorDlg dialog

CStatusMonitorDlg::CStatusMonitorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStatusMonitorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStatusMonitorDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON_Star);
}

void CStatusMonitorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStatusMonitorDlg)
	DDX_Control(pDX, IDC_STATIC_Printer_Queue, m_Printer_Queue);
	DDX_Control(pDX, IDC_EDIT_StarIOModelVersion, m_StarIOModelVersion);
	DDX_Control(pDX, IDC_STATIC_Second, m_Second);
	DDX_Control(pDX, IDC_STATIC_Status, m_Status);
	DDX_Control(pDX, IDC_STATIC_SelectDevice, m_SelectDevice);
	DDX_Control(pDX, IDC_STATIC_GetStatus, m_GetStatusFrame);
	DDX_Control(pDX, IDC_STATIC_PortSetting, m_PortSetting);
	DDX_Control(pDX, IDC_STATIC_Port, m_Port);
	DDX_Control(pDX, IDC_STATIC_IF, m_IF);
	DDX_Control(pDX, IDC_STATIC_PrinterPort, m_PrinterPortLabel);
	DDX_Control(pDX, IDC_STATIC_RawData, m_LabelRawData);
	DDX_Control(pDX, IDC_STATIC_ETBCounter, m_ETBCounter);
	DDX_Control(pDX, IDC_STATIC_Presenterstate, m_Presenterstate);
	DDX_Control(pDX, IDC_BUTTON_GetModelVersion, m_GetModelVersion);
	DDX_Control(pDX, IDC_BUTTON_DeviceReset, m_DeviceReset);
	DDX_Control(pDX, IDC_BUTTON_GetStatus, m_GetStatus);
	DDX_Control(pDX, IDC_COMBO_Interval, m_Interval);
	DDX_Control(pDX, IDC_EDIT_StarIOPortSettings, m_StarIOPortSettings);
	DDX_Control(pDX, IDC_EDIT_StarIOPort, m_StarIOPort);
	DDX_Control(pDX, IDC_COMBO_StarIOIF, m_StarIOIF);
	DDX_Control(pDX, IDC_EDIT_PrinterPort, m_PrinterPort);
	DDX_Control(pDX, IDC_COMBO_Printer, m_Printer);
	DDX_Control(pDX, IDC_EDIT_ETBCounterText, m_ETBCounterText);
	DDX_Control(pDX, IDC_EDIT_PresenterStateText, m_PresenterStateText);
	DDX_Control(pDX, IDC_COMBO_RawData, m_RawData);
	DDX_Control(pDX, IDC_CHECK_ETBavailable, m_ETBavailable);
	DDX_Control(pDX, IDC_CHECK_Presenterpaperjam, m_Presenterpaperjam);
	DDX_Control(pDX, IDC_CHECK_BMerror, m_BMerror);
	DDX_Control(pDX, IDC_CHECK_Papernearemptyinner, m_Papernearemptyinner);
	DDX_Control(pDX, IDC_CHECK_Paperempty, m_Paperempty);
	DDX_Control(pDX, IDC_CHECK_Headthermistorerror, m_Headthermistorerror);
	DDX_Control(pDX, IDC_CHECK_Receivebufferoverflow, m_Receivebufferoverflow);
	DDX_Control(pDX, IDC_CHECK_Commanderror, m_Commanderror);
	DDX_Control(pDX, IDC_CHECK_Voltageerror, m_Voltageerror);
	DDX_Control(pDX, IDC_CHECK_Cuttererror, m_Cuttererror);
	DDX_Control(pDX, IDC_CHECK_Unrecoverbleerror, m_Unrecoverbleerror);
	DDX_Control(pDX, IDC_CHECK_Overtemperature, m_Overtemperature);
	DDX_Control(pDX, IDC_CHECK_Coveropen, m_Coveropen);
	DDX_Control(pDX, IDC_CHECK_Printeroffline, m_Printeroffline);
	DDX_Control(pDX, IDC_CHECK_PowerOff, m_PowerOff);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CStatusMonitorDlg, CDialog)
	//{{AFX_MSG_MAP(CStatusMonitorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(__MSG_SUB_THREAD1, OnMsgFromSubThread1)
	ON_BN_CLICKED(IDC_BUTTON_GetStatus, OnBUTTONGetStatus)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON_DeviceReset, OnBUTTONDeviceReset)
	ON_BN_CLICKED(IDC_RADIO_PrinterDriver, OnRADIOPrinterDriver)
	ON_BN_CLICKED(IDC_RADIO_StarIO, OnRADIOStarIO)
	ON_BN_CLICKED(IDC_RADIO_Manual, OnRADIOManual)
	ON_BN_CLICKED(IDC_RADIO_Interval, OnRADIOInterval)
	ON_CBN_SELCHANGE(IDC_COMBO_Printer, OnSelchangeCOMBOPrinter)
	ON_CBN_SELCHANGE(IDC_COMBO_StarIOIF, OnSelchangeCOMBOStarIOIF)
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COMBO_Interval, OnSelchangeCOMBOInterval)
	ON_BN_CLICKED(IDC_BUTTON_GetModelVersion, OnBUTTONGetModelVersion)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStatusMonitorDlg message handler

BOOL CStatusMonitorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// add menu item to system menu "Version Info..."

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// large icon
	SetIcon(m_hIcon, FALSE);		// small icon
	
	SetWindowTitleNormal();

	int pNumArgs;
	LPWSTR *pCommandLine;
	pCommandLine=CommandLineToArgvW(GetCommandLineW(),&pNumArgs);
	bool rt=InitDeviceList(pCommandLine,pNumArgs);
	m_SubThread1.hWndTarget = this->m_hWnd;
	return TRUE; 
}

void CStatusMonitorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CStatusMonitorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// center of client area
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// draw icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CStatusMonitorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

LRESULT CStatusMonitorDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	
	return CDialog::DefWindowProc(message, wParam, lParam);
}

BOOL CStatusMonitorDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	
	return CDialog::OnCommand(wParam, lParam);
}

void CStatusMonitorDlg::OnClose() 
{
	
	m_FinProgram();
}


bool CStatusMonitorDlg::InitDeviceList(LPWSTR *pCommandLine,int pNumArgs)
{
	
	CButton * m_mRadio_PrinterDriver = (CButton *)GetDlgItem(IDC_RADIO_PrinterDriver);	// getting handler of radio button
	CButton * m_mRadio_StarIO = (CButton *)GetDlgItem(IDC_RADIO_StarIO);	// getting handler of radio button
	// Initial
	PrinterPowerOn=false;	// Power Off
	m_StarIOIF.AddString (_T("Parallel (LPT)"));
	m_StarIOIF.AddString (_T("Serial (COM)"));
	m_StarIOIF.AddString (_T("USB Vendor Class"));
	m_StarIOIF.AddString (_T("USB Printer Class"));
	m_StarIOIF.AddString (_T("LAN"));
	m_StarIOIF.SetCurSel(0);
	KeepStarIOPortType=0;
	SetDlgItemText(IDC_EDIT_StarIOPortSettings,_T("9600,n,8,1,h"));
	
	// Manual or Interval
	m_Interval.AddString (_T("1"));
	m_Interval.AddString (_T("2"));
	m_Interval.AddString (_T("5"));
	m_Interval.AddString (_T("10"));
	m_Interval.SetCurSel(2);	// Default Interval is 2sec
	GetStatusManual=true;	// Dafault is manual
	// Command Line
	if(pNumArgs>2)
	{
		if(_wcsicmp(pCommandLine[2],L"1") == 0)
		{
			GetStatusManual=false;
			m_Interval.SetCurSel(0);
		}
		else
		{
			if(_wcsicmp(pCommandLine[2],L"2") == 0)
			{
				GetStatusManual=false;
				m_Interval.SetCurSel(1);
			}
			else
			{
				if(_wcsicmp(pCommandLine[2],L"5") == 0)
				{
					GetStatusManual=false;
					m_Interval.SetCurSel(2);
				}
				else
				{
					if(_wcsicmp(pCommandLine[2],L"10") == 0)
					{
						GetStatusManual=false;
						m_Interval.SetCurSel(3);
					}
					else
					{
						if(_wcsicmp(pCommandLine[2],L"M") == 0)
						{
							GetStatusManual=true;
						}
						else
						{
							MessageBox( _T("Illegal second parameter ! (Set M/1/2/5/10)"), _T("Status Monitor"), MB_OK );
						}
					}
				}
			}
		}
	}

	if(pNumArgs>1)
	{
		if(_wcsicmp(pCommandLine[1],L"Printer") == 0)
		{	// Command Line = Select Printer
			if(GetPrinterQueueList())	// Found Printer Queue
			{
				m_mRadio_PrinterDriver->SetCheck(1);	// Check On
				m_mRadio_StarIO->SetCheck(0);	// Check Off
				ModePrinter=true;
				m_SubThread1.ModePrinter_s=true;
				if(pNumArgs>3)
				{	// Search Printer Queue
					SerarchPrinterQueue(&pCommandLine[3][0]);
				}
			}
			else
			{	// Not found Printer -> StarIO
				m_mRadio_PrinterDriver->SetCheck(0);	// Check Off
				m_mRadio_PrinterDriver->EnableWindow(false);
				m_mRadio_StarIO->SetCheck(1);	// Check On
				ModePrinter=false;
				m_SubThread1.ModePrinter_s=false;
			}
		}
		else
		{	//  not Printer
			if(_wcsicmp(pCommandLine[1],L"Port") == 0)
			{	// Command Line = StarIO
				m_mRadio_PrinterDriver->SetCheck(0);	// Check Off
				m_mRadio_StarIO->SetCheck(1);	// Check On
				if(GetPrinterQueueList())	// Found Printer Queue
				{
				}
				else
				{
					m_mRadio_PrinterDriver->EnableWindow(false);
				}
				ModePrinter=false;
				m_SubThread1.ModePrinter_s=false;
				if(pNumArgs>3)
				{	// Search Port
					int PortIndex=SerarchPort(&pCommandLine[3][0]);
					m_StarIOIF.SetCurSel(PortIndex);
					KeepStarIOPortType=PortIndex;
					if(pNumArgs>4)
					{
						CString s;
						s=&pCommandLine[4][0];
						SetDlgItemText(IDC_EDIT_StarIOPort,s);
						if(pNumArgs>5)
						{
							s=&pCommandLine[5][0];
							SetDlgItemText(IDC_EDIT_StarIOPortSettings,s);
						}
					}
				}
			}
			else
			{
				MessageBox( _T("Illegal first parameter ! (Set Printer/Port)"), _T("Status Monitor"), MB_OK );
				if(GetPrinterQueueList())	// Found Printer Queue
				{
					m_mRadio_PrinterDriver->SetCheck(1);	// Check On
					m_mRadio_StarIO->SetCheck(0);	// Check Off
					ModePrinter=true;
					m_SubThread1.ModePrinter_s=true;
				}
				else	// not Found Printer Queue
				{
					m_mRadio_PrinterDriver->SetCheck(0);	// Check Off
					m_mRadio_PrinterDriver->EnableWindow(false);
					m_mRadio_StarIO->SetCheck(1);	// Check On
					ModePrinter=false;
					m_SubThread1.ModePrinter_s=false;
				}
			}
		}
	}
	else
	{
		if(GetPrinterQueueList())	// Found Printer Queue
		{
			m_mRadio_PrinterDriver->SetCheck(1);	// Check On
			m_mRadio_StarIO->SetCheck(0);	// Check Off
			ModePrinter=true;
			m_SubThread1.ModePrinter_s=true;
		}
		else	// not Found Printer Queue
		{
			m_mRadio_PrinterDriver->SetCheck(0);	// Check Off
			m_mRadio_PrinterDriver->EnableWindow(false);
			m_mRadio_StarIO->SetCheck(1);	// Check On
			ModePrinter=false;
			m_SubThread1.ModePrinter_s=false;
			OnSelchangeCOMBOStarIOIF();
		}
	}
	SelectPrinterQueueOrStarIO(ModePrinter);
	SelectGetStatusManualOrInterval(GetStatusManual);
	StatusSet_PrinterPowerOnOff(PrinterPowerOn);
	if(GetStatusManual == false)
	{
		OnStartTimer();
	}

	return true;
}

void CStatusMonitorDlg::OnRADIOPrinterDriver() 
{
	GetStatusManual=true;
	SelectGetStatusManualOrInterval(GetStatusManual);
	OnStopTimer();
	CButton * m_mRadio_PrinterDriver = (CButton *)GetDlgItem(IDC_RADIO_PrinterDriver);	// getting handler of radio button
	m_mRadio_PrinterDriver->SetCheck(1);	// Check On
	CButton * m_mRadio_StarIO = (CButton *)GetDlgItem(IDC_RADIO_StarIO);	// getting handler of radio button
	m_mRadio_StarIO->SetCheck(0);	// Check Off
	ModePrinter=true;
	SelectPrinterQueueOrStarIO(ModePrinter);
}

void CStatusMonitorDlg::OnSelchangeCOMBOPrinter() 
{
	SetPrinterPortBox();
}

void CStatusMonitorDlg::OnRADIOStarIO() 
{
	GetStatusManual=true;
	SelectGetStatusManualOrInterval(GetStatusManual);
	OnStopTimer();
	CButton * m_mRadio_StarIO = (CButton *)GetDlgItem(IDC_RADIO_StarIO);	// getting handler of radio button
	m_mRadio_StarIO->SetCheck(1);	// Check On
	CButton * m_mRadio_PrinterDriver = (CButton *)GetDlgItem(IDC_RADIO_PrinterDriver);	// getting handler of radio button
	m_mRadio_PrinterDriver->SetCheck(0);	// Check Off
	ModePrinter=false;
	SelectPrinterQueueOrStarIO(ModePrinter);
	OnSelchangeCOMBOStarIOIF();
}

void CStatusMonitorDlg::OnBUTTONGetModelVersion() 
{
	BOOL	ret;
	// getting model and version is executed in sub thread
	if(!CheckPortNameStarIO())
	{
		MessageBox( _T("Wrong port name !"), _T("Status Monitor"), MB_OK );
		GetStatusManual=true;
		SelectGetStatusManualOrInterval(GetStatusManual);
		OnStopTimer();
		PrinterPowerOn=false;
		StatusSet_PrinterPowerOnOff(PrinterPowerOn);
		return;
	}
	m_SubThread1.ExecuteMode=__EXEC_READ_MODEL;
	SetWindowTitleReadModel();
	ret=m_SubThread1.StartSubThread();
	if(ret == false)
	{
		PrinterPowerOn=false;
		StatusSet_PrinterPowerOnOff(PrinterPowerOn);
		SetWindowTitleNormal();
	}
}

void CStatusMonitorDlg::OnSelchangeCOMBOStarIOIF() 
{
	int	index;
	CString	buf;
	int len;
	index=m_StarIOIF.GetCurSel();
	switch(index)
	{
	case 0:	// LPT
		if(KeepStarIOPortType != 0)
		{
			m_SubThread1.PortUSBPrinterClass=false;
			SetDlgItemText(IDC_EDIT_StarIOPort,_T("LPT1"));
		}
		else
		{
			GetDlgItemText(IDC_EDIT_StarIOPort,buf);
			if(len=buf.GetLength())
			{
			}
			else
			{
				SetDlgItemText(IDC_EDIT_StarIOPort,_T("LPT1"));
			}
		}
		m_PortSetting.EnableWindow(false);
		m_StarIOPortSettings.EnableWindow(false);
		KeepStarIOPortType=0;
		break;
	case 1:	// COM
		if(KeepStarIOPortType != 1)
		{
			m_SubThread1.PortUSBPrinterClass=false;
			SetDlgItemText(IDC_EDIT_StarIOPort,_T("COM1"));
		}
		else
		{
			GetDlgItemText(IDC_EDIT_StarIOPort,buf);
			if(len=buf.GetLength())
			{
			}
			else
			{
				SetDlgItemText(IDC_EDIT_StarIOPort,_T("COM1"));
			}
		}
		m_PortSetting.EnableWindow(true);
		m_StarIOPortSettings.EnableWindow(true);
		KeepStarIOPortType=1;
		break;
	case 2:	// usbven
		if(KeepStarIOPortType != 2)
		{
			m_SubThread1.PortUSBPrinterClass=false;
			SetDlgItemText(IDC_EDIT_StarIOPort,_T("usbven:"));
		}
		else
		{
			GetDlgItemText(IDC_EDIT_StarIOPort,buf);
			if(len=buf.GetLength())
			{
			}
			else
			{
				SetDlgItemText(IDC_EDIT_StarIOPort,_T("usbven:"));
			}
		}
		m_PortSetting.EnableWindow(false);
		m_StarIOPortSettings.EnableWindow(false);
		KeepStarIOPortType=2;
		break;
	case 3:	// usbprn
		if(KeepStarIOPortType != 3)
		{
			m_SubThread1.PortUSBPrinterClass=true;
			SetDlgItemText(IDC_EDIT_StarIOPort,_T("usbprn:"));
		}
		else
		{
			GetDlgItemText(IDC_EDIT_StarIOPort,buf);
			if(len=buf.GetLength())
			{
			}
			else
			{
				SetDlgItemText(IDC_EDIT_StarIOPort,_T("usbprn:"));
			}
		}
		m_PortSetting.EnableWindow(false);
		m_StarIOPortSettings.EnableWindow(false);
		KeepStarIOPortType=3;
		break;
	case 4:	// LAN
		if(KeepStarIOPortType != 4)
		{
			m_SubThread1.PortUSBPrinterClass=false;
			SetDlgItemText(IDC_EDIT_StarIOPort,_T("TCP:"));
		}
		else
		{
			GetDlgItemText(IDC_EDIT_StarIOPort,buf);
			if(len=buf.GetLength())
			{
			}
			else
			{
				SetDlgItemText(IDC_EDIT_StarIOPort,_T("TCP:"));
			}
		}
		m_PortSetting.EnableWindow(false);
		m_StarIOPortSettings.EnableWindow(false);
		KeepStarIOPortType=4;
		break;
	}
}

void CStatusMonitorDlg::OnRADIOManual() 
{
	GetStatusManual=true;
	SelectGetStatusManualOrInterval(GetStatusManual);
	OnStopTimer();
}

void CStatusMonitorDlg::OnRADIOInterval() 
{
	GetStatusManual=false;
	SelectGetStatusManualOrInterval(GetStatusManual);
	OnStartTimer();
}

void CStatusMonitorDlg::OnTimer(UINT nIDEvent) 
{
	
	if(TimerState != __TIMER_STATE_STOP)
	{
		if(m_SubThread1.iSt ==__ST_FIN)
		{
			GetStatusExecute();
		}
	}
	else
	{
		KillTimer(m_nTimer);
	}
	CDialog::OnTimer(nIDEvent);
}
void CStatusMonitorDlg::OnStartTimer() 
{
	int index;
	long	tm;
	index=m_Interval.GetCurSel();
	switch(index)
	{
	default:
	case 0:
		tm=1 * 1000;
		break;
	case 1:
		tm=1 * 2000;
		break;
	case 2:
		tm=1 * 5000;
		break;
	case 3:
		tm=1 * 10000;
		break;
	}
	m_nTimer = SetTimer(__TIMER_ID1, tm, 0);
	TimerState=__TIMER_STATE_RUN;
	if(m_SubThread1.iSt ==__ST_FIN)
	{
		GetStatusExecute();
	}
}

void CStatusMonitorDlg::OnStopTimer() 
{
	TimerState=__TIMER_STATE_STOP;
	if(m_SubThread1.iSt ==__ST_FIN)
	{
		KillTimer(m_nTimer);
	}
}

void CStatusMonitorDlg::OnSelchangeCOMBOInterval() 
{
	int index;
	long	tm;
	index=m_Interval.GetCurSel();
	switch(index)
	{
	default:
	case 0:
		tm=1 * 1000;
		break;
	case 1:
		tm=1 * 2000;
		break;
	case 2:
		tm=1 * 5000;
		break;
	case 3:
		tm=1 * 10000;
		break;
	}
	if(TimerState != __TIMER_STATE_STOP)
	{
		KillTimer(m_nTimer);
	}
	m_nTimer = SetTimer(__TIMER_ID1, tm, 0);
	TimerState=__TIMER_STATE_RUN;
	if(m_SubThread1.iSt ==__ST_FIN)
	{
		GetStatusExecute();
	}
}

void CStatusMonitorDlg::OnBUTTONGetStatus() 
{
	if(m_SubThread1.iSt ==__ST_FIN)
	{
		GetStatusExecute();
	}
}

void CStatusMonitorDlg::GetStatusExecutePrinter() 
{
    HKEY	hKey;
    DWORD	dwSize;
	HMODULE	hPLUGINDLL;
    wchar_t	*pstlmDllPath;
	wchar_t	*pstsmonDllPath;
	BOOL	ret;
	STATUSCHK	stlmplugIn;
	int	i;

	m_SubThread1.ModePrinter_s=true;
	// Gets full path of stlm.dll(language monitor) from registry
    if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, SMJPRINTER_LMPLUGREG_NAME, 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS)
	{
		RegQueryValueEx(hKey, NULL, NULL, NULL,(unsigned char *) NULL, &dwSize);
		pstlmDllPath = (wchar_t *) LocalAlloc(LPTR, dwSize + 1);
		if (pstlmDllPath == NULL)
		{
			RegCloseKey(hKey);
			return;
		}
		if(RegQueryValueEx(hKey, NULL, NULL, NULL,(BYTE *) pstlmDllPath, &dwSize) == ERROR_SUCCESS)
		{
			dwSize=wcslen(pstlmDllPath) - wcslen(SMJPRINTER_STLM_NAME) + wcslen(SMJPRINTER_STSMON_NAME)+1;
			pstsmonDllPath = (wchar_t *) LocalAlloc(LPTR, dwSize * sizeof(wchar_t) + 1);
			if (pstsmonDllPath == NULL)
			{
				RegCloseKey(hKey);
				LocalFree(pstlmDllPath);
				return;
			}
			wmemcpy(pstsmonDllPath, pstlmDllPath, wcslen(pstlmDllPath));
			wchar_t * res = wcsrchr( pstsmonDllPath, '\\' );
			if ( res )
			{
			    // Gets full path of stsmon.dll
				wmemcpy(res, SMJPRINTER_STSMON_NAME, sizeof(SMJPRINTER_STSMON_NAME)/sizeof(wchar_t));		
				// Maps stsmon.dll by LoadLibrary() function
				hPLUGINDLL = LoadLibrary((LPCWSTR)pstsmonDllPath);
				LocalFree(pstlmDllPath);
				LocalFree(pstsmonDllPath);
				// Retrieves the address of the GetStarPrinterStatus() function 
				stlmplugIn = (STATUSCHK) GetProcAddress(hPLUGINDLL, GetStarPrinterStatus);
				if(stlmplugIn != NULL)
				{
					StarPrinterStatus_2	StarPrinterStatus_r;
					memset(&StarPrinterStatus_r, 0, sizeof(StarPrinterStatus_2));
					SetWindowTitleReading();
					// Executes getting status from printer
					for(i=0;i<4;i++)
					{
						if(ret=(*stlmplugIn)(PrinterName , &StarPrinterStatus_r))
						{	// success
							break;
						}
						Sleep(50);	// retry
					}
					if(ret)
					{	// success
						StarPrinterStatus_d=StarPrinterStatus_r;
						if(StarPrinterStatus_d.rawLength == 0)	// the length of status is zero. it means disable getting status in Language Monitor
						{
							MessageBox( _T("Can't get printer status. Check the printer driver setting !"), _T("Status Monitor"), MB_OK );
							GetStatusManual=true;
							SelectGetStatusManualOrInterval(GetStatusManual);
							OnStopTimer();
							PrinterPowerOn=false;
							StatusSet_PrinterPowerOnOff(PrinterPowerOn);
							SetWindowTitleNormal();
						}
						else
						{
							PrinterPowerOn=true;
							StatusSet_PrinterPowerOnOff(PrinterPowerOn);
							ShowStatus();
							SetWindowTitleNormal();
						}
					}
					else
					{	// unsuccess
						PrinterPowerOn=false;
						StatusSet_PrinterPowerOnOff(PrinterPowerOn);
						SetWindowTitleNormal();
					}
				}
				else
				{
					MessageBox( _T("Can't find stsmon.dll !"), _T("Status Monitor"), MB_OK );
					GetStatusManual=true;
					SelectGetStatusManualOrInterval(GetStatusManual);
					OnStopTimer();
					PrinterPowerOn=false;
					StatusSet_PrinterPowerOnOff(PrinterPowerOn);
				}
				// stsmon.dll is removed from the address space of the current process
				FreeLibrary(hPLUGINDLL);
			}
			else
			{
				MessageBox( _T("Can't find stsmon.dll !"), _T("Status Monitor"), MB_OK );
				GetStatusManual=true;
				SelectGetStatusManualOrInterval(GetStatusManual);
				OnStopTimer();
				PrinterPowerOn=false;
				StatusSet_PrinterPowerOnOff(PrinterPowerOn);
			}
		}
		else
		{
			MessageBox( _T("Language Monitor is not installed !"), _T("Status Monitor"), MB_OK );
			GetStatusManual=true;
			SelectGetStatusManualOrInterval(GetStatusManual);
			OnStopTimer();
			PrinterPowerOn=false;
			StatusSet_PrinterPowerOnOff(PrinterPowerOn);
		}
       }
	else
	{
		MessageBox( _T("Language Monitor is not installed !"), _T("Status Monitor"), MB_OK );
		GetStatusManual=true;
		SelectGetStatusManualOrInterval(GetStatusManual);
		OnStopTimer();
		PrinterPowerOn=false;
		StatusSet_PrinterPowerOnOff(PrinterPowerOn);
	}
    RegCloseKey(hKey);
}

void CStatusMonitorDlg::GetStatusExecutePort() 
{
	BOOL	ret;

	if(!CheckPortNameStarIO())
	{
		MessageBox( _T("Wrong port name !"), _T("Status Monitor"), MB_OK );
		GetStatusManual=true;
		SelectGetStatusManualOrInterval(GetStatusManual);
		OnStopTimer();
		PrinterPowerOn=false;
		StatusSet_PrinterPowerOnOff(PrinterPowerOn);
		return;
	}
	m_SubThread1.ModePrinter_s=false;
	memset(&m_SubThread1.StarPrinterStatus_m, 0, sizeof(StarPrinterStatus));
	m_SubThread1.ExecuteMode=__EXEC_READ_STATUS;
	SetWindowTitleReading();
	ret=m_SubThread1.StartSubThread();
	if(ret == false)
	{
		PrinterPowerOn=false;
		StatusSet_PrinterPowerOnOff(PrinterPowerOn);
		SetWindowTitleNormal();
	}
}

void CStatusMonitorDlg::GetStatusExecute() 
{
	if(ModePrinter == true)	// Printer
	{
		GetStatusExecutePrinter();
    }
	else	// Getting status is executed in sub thread
	{
		GetStatusExecutePort();
	}
}

void CStatusMonitorDlg::OnBUTTONDeviceReset() 
{
	BOOL	ret;
	// resetting device is executed in sub thread
	if(!CheckPortNameStarIO())
	{
		MessageBox( _T("Wrong port name !"), _T("Status Monitor"), MB_OK );
		GetStatusManual=true;
		SelectGetStatusManualOrInterval(GetStatusManual);
		OnStopTimer();
		PrinterPowerOn=false;
		StatusSet_PrinterPowerOnOff(PrinterPowerOn);
		return;
	}
	m_SubThread1.ExecuteMode=__EXEC_RESET_DEVICE;
	SetWindowTitleResetDevice();
	ret=m_SubThread1.StartSubThread();
	if(ret == false)
	{
		PrinterPowerOn=false;
		StatusSet_PrinterPowerOnOff(PrinterPowerOn);
		SetWindowTitleNormal();
	}
}

bool CStatusMonitorDlg::CheckPortNameStarIO(void)
{
	bool ret=false;
	int	index;
	CString PortNameBuf;
	CString PortSettingsBuf;
	GetDlgItemText(IDC_EDIT_StarIOPort,PortNameBuf);
	GetDlgItemText(IDC_EDIT_StarIOPortSettings,PortSettingsBuf);
	index=m_StarIOIF.GetCurSel();
	switch(index)
	{
	case 0:	// LPT
		if((wcsncmp(PortNameBuf,_T("LPT"),3) == 0) || (wcsncmp(PortNameBuf,_T("lpt"),3) == 0))
		{
			PortSettingsBuf=_T("");
			ret=true;
		}
		break;
	case 1:	// COM
		if((wcsncmp(PortNameBuf,_T("COM"),3) == 0) || (wcsncmp(PortNameBuf,_T("com"),3) == 0))
		{
			ret=true;
		}
		break;
	case 2:	// usbven
		if((wcsncmp(PortNameBuf,_T("USBVEN"),6) == 0) || (wcsncmp(PortNameBuf,_T("usbven"),6) == 0))
		{
			PortSettingsBuf=_T("");
			ret=true;
		}
		break;
	case 3:	// usbprn
		if((wcsncmp(PortNameBuf,_T("USBPRN"),6) == 0) || (wcsncmp(PortNameBuf,_T("usbprn"),6) == 0))
		{
			PortSettingsBuf=_T("");
			ret=true;
		}
		break;
	case 4:	// LAN
		if((wcsncmp(PortNameBuf,_T("TCP"),3) == 0) || (wcsncmp(PortNameBuf,_T("tcp"),3) == 0) || (wcsncmp(PortNameBuf,_T("IP_"),3) == 0))
		{
			PortSettingsBuf=_T("");
			ret=true;
		}
		break;
	}
	if(ret == true)
	{
		m_SubThread1.portName=PortNameBuf;
		m_SubThread1.portSettings=PortSettingsBuf;
	}
	return ret;
}

void CStatusMonitorDlg::SetWindowTitleNormal(void) 
{
	CString strWindowTitle;
	strWindowTitle.LoadString(IDS_WindowTitle);
	SetWindowText(strWindowTitle);
}

void CStatusMonitorDlg::SetWindowTitleReading(void) 
{
	CString strWindowTitle;
	strWindowTitle.LoadString(IDS_Reading);
	SetWindowText(strWindowTitle);
}

void CStatusMonitorDlg::SetWindowTitleResetDevice(void) 
{
	CString strWindowTitle;
	strWindowTitle.LoadString(IDS_ResetDevice);
	SetWindowText(strWindowTitle);
}

void CStatusMonitorDlg::SetWindowTitleReadModel(void) 
{
	CString strWindowTitle;
	strWindowTitle.LoadString(IDS_ReadModel);
	SetWindowText(strWindowTitle);
}

void CStatusMonitorDlg::StatusSet_PrinterPowerOnOff(bool PowerOn)
{

	m_PowerOff.SetCheck(!PowerOn);
	m_Printeroffline.EnableWindow(PowerOn);
	m_Coveropen.EnableWindow(PowerOn);
	m_Overtemperature.EnableWindow(PowerOn);
	m_Unrecoverbleerror.EnableWindow(PowerOn);
	m_Cuttererror.EnableWindow(PowerOn);
	m_Voltageerror.EnableWindow(PowerOn);
	m_Commanderror.EnableWindow(PowerOn);
	m_Receivebufferoverflow.EnableWindow(PowerOn);
	m_Headthermistorerror.EnableWindow(PowerOn);
	m_Paperempty.EnableWindow(PowerOn);
	m_Papernearemptyinner.EnableWindow(PowerOn);
	m_BMerror.EnableWindow(PowerOn);
	m_Presenterpaperjam.EnableWindow(PowerOn);
	m_PresenterStateText.EnableWindow(PowerOn);
	m_ETBavailable.EnableWindow(PowerOn);
	m_ETBCounterText.EnableWindow(PowerOn);
	m_RawData.EnableWindow(PowerOn);
	m_Presenterstate.EnableWindow(PowerOn);
	m_ETBCounter.EnableWindow(PowerOn);
	m_LabelRawData.EnableWindow(PowerOn);
}

int CStatusMonitorDlg::GetPrinterQueueList(void)
{
	int				n;
	int				i;
	int				m = 0;
	PRINTER_INFO	PInfo;
	POSITION		pos;

	m_PrinterCtrl.ClearAllMember();
	m_PrinterCtrl.EnumPrinters();
	n = m_PrinterCtrl.PrinterList.GetCount();


	pos = m_PrinterCtrl.PrinterList.GetHeadPosition();
	if(!pos){
		return 0;
	}
	for ( i = 0; i < n; i++ ){
		PInfo = m_PrinterCtrl.PrinterList.GetNext(pos);

		if( PInfo.ModelName.Find( _T("Star TUP500 Presenter (TUP592)") ) == 0 ){
			m_Printer.AddString (PInfo.PrinterName );
			m++;
		}
		if( PInfo.ModelName.Find( _T("Star TUP500 (TUP542)") ) == 0 ){
			m_Printer.AddString (PInfo.PrinterName);
			m++;
		}
	}
	m_Printer.SetCurSel(0);
	if(m)
	{
		SetPrinterPortBox();
	}
	return m;
}

void CStatusMonitorDlg::SetPrinterPortBox(void)
{
	int				n;
	int				i;
	int				m = 0;
	PRINTER_INFO	PInfo;
	POSITION		pos;
	CString			s;
	CString			port;

	m_PrinterCtrl.ClearAllMember();
	m_PrinterCtrl.EnumPrinters();
	n = m_PrinterCtrl.PrinterList.GetCount();

	i= m_Printer.GetCurSel();
	m_Printer.GetLBText(i,s);

	pos = m_PrinterCtrl.PrinterList.GetHeadPosition();
	if(!pos){
		return;
	}
	for ( i = 0; i < n; i++ ){
		PInfo = m_PrinterCtrl.PrinterList.GetNext(pos);

		if( PInfo.PrinterName.Compare( s ) == 0 ){
			port=PInfo.PortName;
			m++;
			break;
		}
	}
	PrinterName=PInfo.PrinterName;
	m_PrinterPort.SetWindowText(port);
}

void CStatusMonitorDlg::SerarchPrinterQueue(LPCWSTR PrinterQueue)
{
	CString	t;
	CString	s;
	int n;
	int i;

	s=PrinterQueue;
	n=m_Printer.GetCount();
	for(i=0;i<n;i++)
	{
		int j = m_Printer.GetLBTextLen(i);
		m_Printer.GetLBText(i,t);

		if(s.Compare(t) == 0)
		{
			m_Printer.SetCurSel(i);
			SetPrinterPortBox();
			break;
		}
	}
}

int CStatusMonitorDlg::SerarchPort(LPCWSTR clPort)
{
	CString	t;
	CString	s;
	int PortIndex;

	s=clPort;
	m_SubThread1.PortUSBPrinterClass=false;
	if(s.Compare(_T("LPT")) == 0)
	{
		PortIndex=0;
	}
	else
	{
		if(s.Compare(_T("COM")) == 0)
		{
			PortIndex=1;
		}
		else
		{
			if(s.Compare(_T("USB Vendor Class")) == 0)
			{
				PortIndex=2;
			}
			else
			{
				if(s.Compare(_T("USB Printer Class")) == 0)
				{
					PortIndex=3;
					m_SubThread1.PortUSBPrinterClass=true;
				}
				else
				{
					if(s.Compare(_T("LAN")) == 0)
					{
						PortIndex=4;
					}
					else
					{
						MessageBox( _T("Illegal third parameter ! (Set LPT/COM/USB Vendor Class/USB Printer Class/LAN)"), _T("Status Monitor"), MB_OK );
						PortIndex=0;
					}
				}
			}
		}
	}
	return PortIndex;
}

void CStatusMonitorDlg::SelectPrinterQueueOrStarIO(bool ModeSelect)
{
	bool Pr = ModeSelect;
	bool StIO =! ModeSelect;
	m_Printer_Queue.EnableWindow(Pr);
	m_Printer.EnableWindow(Pr);
	m_PrinterPortLabel.EnableWindow(Pr);
	m_PrinterPort.EnableWindow(Pr);

	m_IF.EnableWindow(StIO);
	m_StarIOIF.EnableWindow(StIO);
	m_StarIOPort.EnableWindow(StIO);
	m_Port.EnableWindow(StIO);
	m_StarIOPort.EnableWindow(StIO);
	if(ModeSelect == true)
	{
		m_PortSetting.EnableWindow(false);
		m_StarIOPortSettings.EnableWindow(false);
	}
	else
	{
		if(KeepStarIOPortType == 1)	// com
		{
			m_PortSetting.EnableWindow(true);
			m_StarIOPortSettings.EnableWindow(true);
		}
		else
		{
			m_PortSetting.EnableWindow(false);
			m_StarIOPortSettings.EnableWindow(false);
		}
	}
	m_StarIOModelVersion.EnableWindow(StIO);
	if(ModeSelect == true)
	{
		m_GetModelVersion.EnableWindow(false);
		m_StarIOModelVersion.EnableWindow(false);
		m_DeviceReset.EnableWindow(false);
	}
	else
	{
		if(GetStatusManual == true)
		{
			m_GetModelVersion.EnableWindow(true);
			m_StarIOModelVersion.EnableWindow(true);
			m_DeviceReset.EnableWindow(true);
		}
		else
		{
			m_GetModelVersion.EnableWindow(false);
			m_StarIOModelVersion.EnableWindow(false);
			m_DeviceReset.EnableWindow(false);
		}
	}
}

void CStatusMonitorDlg::SelectGetStatusManualOrInterval(bool ModeManual)
{
	CButton * m_mRadio_Manual = (CButton *)GetDlgItem(IDC_RADIO_Manual);	//  getting handler of radio button
	CButton * m_mRadio_Interval = (CButton *)GetDlgItem(IDC_RADIO_Interval);	//  getting handler of radio button

	if(ModeManual)
	{
		m_mRadio_Manual->SetCheck(1);	// Manual Check On
		m_mRadio_Interval->SetCheck(0);	// Interval Check Off
		m_Interval.EnableWindow(false);
		m_Second.EnableWindow(false);
		m_GetStatus.EnableWindow(true);
		if(ModePrinter == true)
		{
			m_GetModelVersion.EnableWindow(false);
			m_StarIOModelVersion.EnableWindow(false);
			m_DeviceReset.EnableWindow(false);
		}
		else
		{
			m_GetModelVersion.EnableWindow(true);
			m_StarIOModelVersion.EnableWindow(true);
			m_DeviceReset.EnableWindow(true);
		}
	}
	else
	{
		m_mRadio_Manual->SetCheck(0);	// Manual Check Off
		m_mRadio_Interval->SetCheck(1);	// Interval Check On
		m_Interval.EnableWindow(true);
		m_Second.EnableWindow(true);
		m_GetStatus.EnableWindow(false);
		m_DeviceReset.EnableWindow(false);
		m_GetModelVersion.EnableWindow(false);
		m_StarIOModelVersion.EnableWindow(false);
	}
}

void CStatusMonitorDlg::ShowStatus() 
{
	CString strBuf;
	int i;
	unsigned char	a;
	CString num;
	int index;
	int StatusRawLength;

    if(StarPrinterStatus_d.offline)
		m_Printeroffline.SetCheck(BST_CHECKED);
	else
		m_Printeroffline.SetCheck(BST_UNCHECKED);

	if(StarPrinterStatus_d.coverOpen)
		m_Coveropen.SetCheck(BST_CHECKED);
	else
		m_Coveropen.SetCheck(BST_UNCHECKED);

	if(StarPrinterStatus_d.overTemp)
		m_Overtemperature.SetCheck(BST_CHECKED);
	else
		m_Overtemperature.SetCheck(BST_UNCHECKED);

    if(StarPrinterStatus_d.unrecoverableError)
		m_Unrecoverbleerror.SetCheck(BST_CHECKED);
	else
		m_Unrecoverbleerror.SetCheck(BST_UNCHECKED);

	if(StarPrinterStatus_d.cutterError)
		m_Cuttererror.SetCheck(BST_CHECKED);
	else
		m_Cuttererror.SetCheck(BST_UNCHECKED);

    if(StarPrinterStatus_d.voltageError)
		m_Voltageerror.SetCheck(BST_CHECKED);
	else
		m_Voltageerror.SetCheck(BST_UNCHECKED);

    if(StarPrinterStatus_d.pageModeCmdError)
		m_Commanderror.SetCheck(BST_CHECKED);
	else
		m_Commanderror.SetCheck(BST_UNCHECKED);

    if(StarPrinterStatus_d.receiveBufferOverflow)
		m_Receivebufferoverflow.SetCheck(BST_CHECKED);
	else
		m_Receivebufferoverflow.SetCheck(BST_UNCHECKED);

    if(StarPrinterStatus_d.headThermistorError)
		m_Headthermistorerror.SetCheck(BST_CHECKED);
	else
		m_Headthermistorerror.SetCheck(BST_UNCHECKED);

	if(StarPrinterStatus_d.receiptPaperEmpty)
		m_Paperempty.SetCheck(BST_CHECKED);
	else
		m_Paperempty.SetCheck(BST_UNCHECKED);

    if(StarPrinterStatus_d.receiptPaperNearEmptyInner)
		m_Papernearemptyinner.SetCheck(BST_CHECKED);
	else
		m_Papernearemptyinner.SetCheck(BST_UNCHECKED);

    if(StarPrinterStatus_d.blackMarkError)
		m_BMerror.SetCheck(BST_CHECKED);
	else
		m_BMerror.SetCheck(BST_UNCHECKED);

    if(StarPrinterStatus_d.presenterPaperJamError)
		m_Presenterpaperjam.SetCheck(BST_CHECKED);
	else
		m_Presenterpaperjam.SetCheck(BST_UNCHECKED);

	switch(StarPrinterStatus_d.presenterState)
	{
	default:
	case 0:
		m_PresenterStateText.SetWindowText(_T("No paper in presenter"));
		break;
	case 1:
		m_PresenterStateText.SetWindowText(_T("Paper loaded(loop)"));
		break;
	case 3:
		m_PresenterStateText.SetWindowText(_T("Paper ejected"));
		break;
	case 6:
		m_PresenterStateText.SetWindowText(_T("Paper retracted"));
		break;
	case 7:
		m_PresenterStateText.SetWindowText(_T("Pull out paper"));
		break;
	}

    if(StarPrinterStatus_d.etbAvailable)
		m_ETBavailable.SetCheck(BST_CHECKED);
	else
		m_ETBavailable.SetCheck(BST_UNCHECKED);

	strBuf.Format(_T("%d"),StarPrinterStatus_d.etbCounter);
	m_ETBCounterText.SetWindowText(strBuf);
	strBuf="RawData : ";
	StatusRawLength=StarPrinterStatus_d.rawLength;
	for(i=0; i< StatusRawLength ;i++)
	{
		a=StarPrinterStatus_d.raw[i];
		num.Format(_T("%02x "),a);
		strBuf=strBuf+num;
	}
	index=m_RawData.GetCount();
	if(index >8)
	{
		m_RawData.DeleteString(9);
	}

	wchar_t dbuffer[9];
	_wstrdate(dbuffer);	// Current Date

	wchar_t tbuffer[9];
	_wstrtime(tbuffer);	// Current Time

	strBuf=strBuf + " " + tbuffer + " " + dbuffer;

	m_RawData.InsertString(0,strBuf);
	m_RawData.SetCurSel(0);
}

LRESULT CStatusMonitorDlg::OnMsgFromSubThread1(WPARAM wParam, LPARAM lParam){
	switch (wParam){
	case __ST_START:
		break;
	case __ST_STOP:
		break;
	case __WARN_01:
		break;
	case __ST_ENDOK:	// success getting status
		switch(	m_SubThread1.ExecuteMode)
		{
		case __EXEC_READ_STATUS:
			if(m_SubThread1.ModePrinter_s  == true)	// Printer
			{
			}
			else	// StarIO
			{
				StarPrinterStatus_d=m_SubThread1.StarPrinterStatus_m;
				PrinterPowerOn=true;
				StatusSet_PrinterPowerOnOff(PrinterPowerOn);
				ShowStatus();
				m_SubThread1.StopSubThread();
				SetWindowTitleNormal();
			}
			break;
		case __EXEC_RESET_DEVICE:
			m_SubThread1.StopSubThread();
			SetWindowTitleNormal();
			break;
		case __EXEC_READ_MODEL:
			SetDlgItemText(IDC_EDIT_StarIOModelVersion,(LPCTSTR)m_SubThread1.ReadFirmwareName );
			m_SubThread1.StopSubThread();
			SetWindowTitleNormal();
			break;
		}
		break;
	case __ST_ENDNG:	// unsuccess getting status
		switch(	m_SubThread1.ExecuteMode)
		{
		case __EXEC_READ_STATUS:
			if(m_SubThread1.ModePrinter_s  == true)	// Printer
			{
			}
			else	// StarIO
			{
				PrinterPowerOn=false;
				StatusSet_PrinterPowerOnOff(PrinterPowerOn);
				SetWindowTitleNormal();
				m_SubThread1.StopSubThread();
			}
			break;
		case __EXEC_RESET_DEVICE:
			m_SubThread1.StopSubThread();
			MessageBox( _T("Error on <Reset Device>. Check the Printer !"), _T("Status Monitor"), MB_OK );
			SetWindowTitleNormal();
			break;
		case __EXEC_READ_MODEL:
			m_SubThread1.StopSubThread();
			MessageBox( _T("Error on <Get Model Version>. Check the Printer !"), _T("Status Monitor"), MB_OK );
			SetWindowTitleNormal();
			break;
		}
		break;
	case __ST_ENDOPENNG:	// port open error
		switch(	m_SubThread1.ExecuteMode)
		{
		case __EXEC_READ_STATUS:
			if(m_SubThread1.ModePrinter_s  == true)	// Printer
			{
			}
			else	// StarIO
			{
				PrinterPowerOn=false;
				StatusSet_PrinterPowerOnOff(PrinterPowerOn);
				SetWindowTitleNormal();
				m_SubThread1.StopSubThread();
			}
			break;
		case __EXEC_RESET_DEVICE:
			m_SubThread1.StopSubThread();
			MessageBox( _T("Error on Open Port. Check the Port !"), _T("Status Monitor"), MB_OK );
			SetWindowTitleNormal();
			break;
		case __EXEC_READ_MODEL:
			m_SubThread1.StopSubThread();
			MessageBox( _T("Error on Open Port. Check the Port !"), _T("Status Monitor"), MB_OK );
			SetWindowTitleNormal();
			break;
		}
		break;
	}
	return true;
}

void CStatusMonitorDlg::m_FinProgram()
{
	int	iRes;
	
	if( m_SubThread1.iSt != __ST_FIN ) {
		MessageBox(  _T("Now getting status. Please wait for a while !"),  _T("Status Monitor"), MB_OK );
		return;
	}
	iRes = MessageBox( _T("Do you want to quit this program ?"),_T("Status Monitor"), MB_OKCANCEL );
	if( iRes == IDOK ){
		CDialog::OnOK();
	}
}

void CStatusMonitorDlg::OnOK() 
{
}

void CStatusMonitorDlg::OnCancel() 
{
	
	m_FinProgram();
}
