// SubThread.h: interface CSubThread
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SUBTHREAD_H__A5D66404_5F02_4BDF_9C01_0E07FEA1B39E__INCLUDED_)
#define AFX_SUBTHREAD_H__A5D66404_5F02_4BDF_9C01_0E07FEA1B39E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "WINUSER.H"
#include "starmicronics/StarIOPort.h"

#define __ST_INIT	( 0x00 )
#define __ST_START	( 0x01 )
#define __ST_RUN0	( 0x02 )
#define __ST_RUN1	( 0x03 )
#define __ST_STOP	( 0x04 )
#define __ST_FIN	( 0x05 )
#define __ST_ENDOK	( 0x06 )
#define __ST_ENDNG	( 0x07 )
#define __ST_ENDOPENNG	( 0x08 )

#define __WARN_01	( 0x11 )

#define	__MSG_SUB_THREAD1		( WM_APP + 100 )

#define __EXEC_READ_STATUS	( 0x00 )
#define __EXEC_RESET_DEVICE	( 0x01 )
#define __EXEC_READ_MODEL	( 0x02 )

class CSubThread  
{
public:
	CSubThread();
	virtual ~CSubThread();

	BOOL	StartSubThread(void);
	BOOL	StopSubThread(void);
	int		iSt;
	HWND	hWndTarget;
	CString	szErrMsg;
	bool	ModePrinter_s;
	CString	portName;
	CString portSettings;
	StarPrinterStatus_2	StarPrinterStatus_m;
	int	ExecuteMode;
	unsigned short	ReadFirmwareName[256];
	bool	PortUSBPrinterClass;

private:
	static void __cdecl m_EntryPoint( void *pParam );
	BOOL	m_CreateThread(void);
	void	m_ThreadProc(void);
	int	ReadModel(void *);
	ULONG	m_HndlThread;
	BOOL	m_StopThreadReq;

};

enum READSTATE {INIT, FIRM, NSB, FIRMSTART, MICR, MICRSTART };

#endif // !defined(AFX_SUBTHREAD_H__A5D66404_5F02_4BDF_9C01_0E07FEA1B39E__INCLUDED_)
